#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lzw.h"

/*

This code is copyright 2004 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

int main(int argc, char *argv[])
{
FILE *in,*out;
unsigned char *buffer;
int filesize;
int t;

  printf("\nLZW decompression/compression routines\n");
  printf("Copyright 2004 - Michael Kohn <mike@mikekohn.net>\n\n");

  if (argc!=4)
  {
    printf("Usage: lzw [ -c <infile> <outfile> / -x <infile> <outfile> ]\n\n");
    exit(0);
  }

  if (strcmp(argv[1],"-c")==0)
  {
    in=fopen(argv[2],"rb");
    if (in==0)
    {
      printf("Can't open input file %s\n",argv[2]);
      exit(0);
    }

    out=fopen(argv[3],"wb");
    if (out==0)
    {
      printf("Can't open output file %s\n",argv[3]);
      fclose(in);
      exit(0);
    }

    fseek(in,0,SEEK_END);
    filesize=ftell(in);
    fseek(in,0,SEEK_SET);
    buffer=malloc(filesize);
    for (t=0; t<filesize; t++) buffer[t]=getc(in);

    lzw_compress(buffer,filesize,out);

    free(buffer);
    fclose(in);
  }
    else
  if (strcmp(argv[1],"-x")==0)
  {
    in=fopen(argv[2],"rb");
    if (in==0)
    {
      printf("Can't open input file %s\n",argv[2]);
      exit(0);
    }

    out=fopen(argv[3],"wb");
    if (out==0)
    {
      printf("Can't open output file %s\n",argv[3]);
      fclose(in);
      exit(0);
    }

    fseek(in,0,SEEK_END);
    filesize=ftell(in);
    fseek(in,0,SEEK_SET);
    buffer=malloc(filesize);
    for (t=0; t<filesize; t++) buffer[t]=getc(in);

    lzw_decompress(buffer,filesize,out);

    free(buffer);
    fclose(in);
    fclose(out);
  }
    else
  {
    printf("Unknown option %s\n",argv[1]);
    exit(0);
  }

  return 0;
}



