#include <stdio.h>
#include <stdlib.h>

#include "lzw.h"

/*

This code is copyright 2004 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

int lzw_compress(unsigned char *buffer, int filesize, FILE *out)
{
struct compress_node_t node[4097];
unsigned char data_stream[256];
int curr_code_size,next_code;
int clear_code,eof_code,curr_code,data_size;
int c,max_colors,code_size,table_start_size,last_code;
unsigned int holding,ptr;
int bitptr,t;
unsigned char color;

  // c=compute_palette(length,picture,gif_header.color_map,(unsigned int *)&gif_header.colors);

  // if (c<2) c=2; /* check this later */
  c=8;

  max_colors=1<<c;
  code_size=c;

  // putc(code_size,out);

  for (c=0; c<max_colors; c++)
  {
    node[c].color=c;
    node[c].right=c+1;
    node[c].down=-1;
  }

  /* node[c-1].right=-1; */

  clear_code=max_colors;
  eof_code=max_colors+1;

#ifdef DEBUG
printf("clear_code=%d\n",clear_code);
printf("eof_code=%d\n",eof_code);
#endif

  table_start_size=max_colors+2;
  next_code=table_start_size;
  curr_code_size=code_size+1;
  curr_code=-1;
  data_size=0;

#ifdef DEBUG
printf("curr_code_size=%d\n",curr_code_size);
#endif

  holding=clear_code;
  bitptr=curr_code_size;
  ptr=0;

  // color=get_color(picture[ptr++],gif_header.color_map,gif_header.colors);
  color=buffer[ptr++];
  curr_code=color;
  last_code=curr_code;

#ifdef DEBUG
printf("curr_code=%d color=%d\n",curr_code,color);
#endif

  while (ptr<filesize)
  {
    // color=get_color(picture[ptr++],gif_header.color_map,gif_header.colors);
    color=buffer[ptr++];

#ifdef DEBUG
printf("curr_code=%d color=%d\n",curr_code,color);
#endif

    if (node[curr_code].down==-1)
    {
      last_code=curr_code;
      node[curr_code].down=next_code;
    }
      else
    {
      last_code=curr_code;
      curr_code=node[curr_code].down;

      while(node[curr_code].color!=color && node[curr_code].right!=-1)
      { curr_code=node[curr_code].right; }

      if (node[curr_code].color!=color && node[curr_code].right==-1)
      { node[curr_code].right=next_code; }
        else
      { continue; }
    }

#ifdef DEBUG
printf("OUTPUT CODE %d  next_code=%d  color=%d\n",last_code,next_code,color);
#endif

    holding=holding+(last_code<<bitptr);
    bitptr=bitptr+curr_code_size;

    node[next_code].right=-1;
    node[next_code].down=-1;
    node[next_code].color=color;
    curr_code=color;

    if ((next_code>>curr_code_size)!=0)
    {
      if (curr_code_size>=12)
      {
        holding=holding+(clear_code<<bitptr);
        bitptr=bitptr+curr_code_size;
        for (c=0; c<max_colors; c++)
        { node[c].down=-1; }

        next_code=table_start_size-1;
        curr_code_size=code_size;
        /* curr_code=0; */
      }
      curr_code_size++;
    }

    next_code++;

#ifdef DEBUG
printf("holding=0x%x   bitptr=%d  code_size=%d\n",holding,bitptr,curr_code_size);
#endif

    while (bitptr>=8)
    {
      data_stream[data_size++]=holding&255;
      holding=holding>>8;
      bitptr=bitptr-8;
      if (data_size>=255)
      {
        // putc(data_size,out);
        t=0;
        while(t!=data_size)
        { t=t+fwrite(data_stream,1,data_size-t,out); }
        data_size=0;
      }
    }
  }

#ifdef DEBUG
printf("Finishing up %d\n",curr_code);
#endif

  holding=holding+(curr_code<<bitptr);
  bitptr=bitptr+curr_code_size;
  holding=holding+(eof_code<<bitptr);
  bitptr=bitptr+curr_code_size;

  while (bitptr>0)
  {
    data_stream[data_size++]=holding&255;
    holding=holding>>8;
    bitptr=bitptr-8;
    if (data_size>=255)
    {
      // putc(data_size,out);
      t=0;
      while(t!=data_size)
      { t=t+fwrite(data_stream,1,data_size-t,out); }
      data_size=0;
    }
  }

#ifdef DEBUG
printf("data_size=%d bitptr=%d\n",data_size,bitptr);
#endif

  if (data_size>0)
  {
    // putc(data_size,out);
    t=0;
    while(t!=data_size)
    { t=t+fwrite(data_stream,1,data_size-t,out); }
  }

  // putc(0,out);
  // putc(';',out);

  return 0;
}


