#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lzw.h"

/*

This code is copyright 2004 by Michael Kohn
You may not use any of this program in your own programs
without permission from Michael Kohn <mike@mikekohn.net>

*/

int lzw_decompress(unsigned char *buffer, int filesize, FILE *out)
{
unsigned char temp_buffer[4097];
struct node_t node[4097];
int t,r,x,y;
int code_size,curr_code_size,data_count;
unsigned int holding,bitptr;
int code,old_code,next_code,start_table_size;
int clear_code,eof_code,mask;
int ptr,fileptr;

  code_size=8;

#ifdef DEBUG
printf("code_size=%d\n",code_size);
#endif

  start_table_size=(1<<code_size);

  for (t=0; t<start_table_size; t++)
  {
    node[t].prev=-1;
    node[t].color=t; 
  }

  clear_code=t;
  eof_code=t+1;
  next_code=t+2;

  code_size++;

  x=0; y=0;
  holding=0;
  bitptr=0;
  curr_code_size=code_size;
  old_code=-1;

  mask=(1<<curr_code_size)-1;
  data_count=0;

  ptr=0;
  fileptr=0;

  while(1)
  {
/*
    if (next_code>=4096)
    {
      curr_code_size--;
      mask=mask>>1;
printf("resetting\n");
    }
*/

    while (bitptr<curr_code_size)
    {
/*
      if (data_count==0)
      {
        data_count=buffer[fileptr++];
        if (fileptr>filesize) break;
        if (data_count==0) break;
      }
*/
      t=buffer[fileptr++];
      holding=holding+(t<<bitptr);
      /* data_count--; */
      bitptr=bitptr+8;
    }

    if (fileptr>filesize)
    {
      printf("EOF! %d\n",fileptr);
      break;
    }

    code=holding&mask;


#ifdef DEBUG
printf("holding=%d bitptr=%d mask=%d curr_code_size=%d\n",holding,bitptr,mask,curr_code_size);
printf(">> code=%d   next_code=%d\n",code,next_code);
#endif

    holding=holding>>curr_code_size;
    bitptr=bitptr-curr_code_size;

    if (code==clear_code)
    {
/* printf("Clear code %d %d\n",fileptr,ftell(out)); */
      curr_code_size=code_size;
      next_code=start_table_size+2;
      old_code=-1;
      mask=(1<<curr_code_size)-1;
#ifdef DEBUG
printf("Clear code\n");
#endif
      continue;
    }
      else
    if (old_code==-1)
    {
#ifdef DEBUG
// printf("old_code=-1 outputting %d\n",temp_buffer[r]);
#endif
      /* printf("0x%06x\n",gif_header.color_map[node[code].color]); */
      // buffer[ptr++]=gif_header.color_map[node[code].color];
      putc(node[code].color,out);
    }
      else
    if (code==eof_code)
    {
      break;
    }
      else
    {
      if (code<next_code)
      {
        t=0;
        r=code;
        while(1)
        {
#ifdef DEBUG
printf("reading table code: %d  %d\n",node[r].color,node[r].prev);
#endif
          temp_buffer[t++]=node[r].color;
          if (node[r].prev==-1) break;
          r=node[r].prev;
        }

        for (r=t-1; r>=0; r--)
        {
          /* printf("0x%06x\n",gif_header.color_map[temp_buffer[r]]); */
          // picture[ptr++]=gif_header.color_map[temp_buffer[r]];
          putc(temp_buffer[r],out);
#ifdef DEBUG
/* printf("outputting %d\n",temp_buffer[r]); */
#endif
        }
#ifdef DEBUG
printf("adding %d to %d\n",temp_buffer[t-1],old_code);
#endif
        node[next_code].color=temp_buffer[t-1];
        node[next_code].prev=old_code;

        if (next_code==mask && mask!=4095)
        {
          curr_code_size++;
          mask=(1<<curr_code_size)-1;
        }
        next_code++;
      }
        else
      {
#ifdef DEBUG
printf("oldcode=%d ptr=%d\n",old_code,ptr);
#endif
        t=0;
        r=old_code;
        while(1)
        {
#ifdef DEBUG
/*
printf("r=%d\n",r);
printf("reading table code: %d  %d t=%d\n",node[r].color,node[r].prev,t);
*/
#endif
          temp_buffer[t++]=node[r].color;
          if (node[r].prev==-1) break;
          r=node[r].prev;
        }
#ifdef DEBUG
printf("t=%d\n",r);
#endif
        node[next_code].color=temp_buffer[t-1];
        node[next_code].prev=old_code;

#ifdef DEBUG
printf("adding %d to %d\n",temp_buffer[t],old_code);
#endif

        if (next_code==mask && mask!=4095)
        {
          curr_code_size++;
          mask=(1<<curr_code_size)-1;
        }

        next_code++;

        for (r=t-1; r>=0; r--)
        {
          /* printf("0x%06x\n",gif_header.color_map[temp_buffer[r]]); */
          // picture[ptr++]=gif_header.color_map[temp_buffer[r]];
          putc(temp_buffer[r],out);

          /* picture[ptr++]=0; */
#ifdef DEBUG
/* printf("outputting %d\n",temp_buffer[r]); */
#endif
        }

        // picture[ptr++]=gif_header.color_map[temp_buffer[t-1]];
        putc(temp_buffer[t-1],out);
      }
    }

    old_code=code;
  }

#ifdef DEBUG
for (x=0; x<next_code; x++)
{
break;
  if (x==eof_code)
  {
    printf("%d: EOF\n",x);
    continue;
  }

  if (x==clear_code)
  {
    printf("%d: CLEAR CODE\n",x);
    continue;
  }

  r=x;
  t=0;
  while(1)
  {
    temp_buffer[t++]=node[r].color;
    if (node[r].prev==-1) break;
    r=node[r].prev;
  }

  printf("%d: ",x);

  for (r=0; r<t; r++)
  {
    printf("%d ",temp_buffer[r]); 
  }

  printf("\n");
}
#endif

  return 0;
}

